!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module LAPACK_Linear
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: lapack_linear.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!LAPACK ׻ΤΥѥå⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * гѹβˡǥ󥰤Ƥʤ
!
                                                                 !=end

module LAPACK_linear
  implicit none
  
  private
                                                                 !=begin
  !=== Public Interface
  public lapack_dgtsv_init  !
  public lapack_dgtsv       ! 3 ϢΩ 1 ()
                                                                 !=end
  integer                   :: N = 10       !ͤϥߡ

  save N

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !LAPACK  DGTSV 롼ν
  !
  subroutine lapack_dgtsv_init(M)

    !=== Input
    integer, intent(in) :: M  !礭
                                                                 !=end
    N = M
  end subroutine lapack_dgtsv_init
  
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  ! 3 ϢΩ 1 ()
  !
  subroutine lapack_dgtsv(A, B, C, D)
    !=== Dependency
    use dc_message, only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none
                                                                 !=begin
    !=== In/Out
    real(8), intent(inout)         :: A(N)      !
    real(8), intent(inout)         :: B(N-1)    !
    real(8), intent(inout)         :: C(N-1)    !
    real(8), intent(inout)         :: D(1,N)    !/
                                                                 !=end
    !=== Work
    integer                        :: NRHS
    integer                        :: INFO
    integer                        :: LDB

    !=== ѿν
    NRHS = 1; INFO = 0; LDB = N
    
    !=== η׻. LAPACK . 
    call DGTSV(N, NRHS, C, A, B, D, LDB, INFO)

    !=== Υǥå. 
    if (INFO /= 0) then
       call MessageNotify("Error", "lapack_linear", &
&                        "INFO is not 0")
       stop
    end if
    
  end subroutine lapack_dgtsv
  
  
end module LAPACK_linear
